{******************************************************************************}
{                                                                              }
{ ETWTest                                                                      }
{                                                                              }
{ The contents of this file are subject to the Mozilla Public License          }
{ Version 1.1 (the "License"); you may not use this file except in             }
{ compliance with the License. You may obtain a copy of the License at         }
{ http://www.mozilla.org/MPL/                                                  }
{                                                                              }
{ Software distributed under the License is distributed on an "AS IS"          }
{ basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the      }
{ License for the specific language governing rights and limitations           }
{ under the License.                                                           }
{                                                                              }
{ The Original Code is uMain.pas released February 2008.                       }
{                                                                              }
{ The Initial Developer of the Original Code is Franck SORIANO.                }
{******************************************************************************}
unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, StdCtrls;

type
  TfrmTestETW = class(TForm)
    sbStatus: TStatusBar;
    TimerRefresh: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    eMsg: TEdit;
    Label3: TLabel;
    eOperationTime: TEdit;
    btTrace: TButton;
    btTraceBegin: TButton;
    btTraceEnd: TButton;
    btTraceException: TButton;
    Label4: TLabel;
    cbTraceLevel: TComboBox;
    cbMsgID: TComboBox;
    procedure btTraceExceptionClick(Sender: TObject);
    procedure btTraceEndClick(Sender: TObject);
    procedure btTraceBeginClick(Sender: TObject);
    procedure btTraceClick(Sender: TObject);
    procedure TimerRefreshTimer(Sender: TObject);
  private
    CurrentTime : int64;

  public
    procedure LogFile(msg : string);
  end;

var
  frmTestETW: TfrmTestETW;

implementation
uses uLogger;
{$R *.dfm}

procedure TfrmTestETW.btTraceBeginClick(Sender: TObject);
begin
  GenericLogger.TraceBegin(
    cbMsgID.ItemIndex,
    eMsg.Text,
    CurrentTime,
    cbTraceLevel.ItemIndex);
end;

procedure TfrmTestETW.btTraceClick(Sender: TObject);
begin
  GenericLogger.Trace(
    cbMsgID.ItemIndex,
    eMsg.Text,
    cbTraceLevel.ItemIndex,
    StrToIntDef(eOperationTime.Text, 0));
end;

procedure TfrmTestETW.btTraceEndClick(Sender: TObject);
begin
  GenericLogger.TraceEnd(
    cbMsgID.ItemIndex,
    eMsg.Text,
    CurrentTime,
    cbTraceLevel.ItemIndex);
end;

procedure TfrmTestETW.btTraceExceptionClick(Sender: TObject);
begin
  try
    Raise Exception.Create(eMsg.Text);
  except
    on e:exception do
    begin
      GenericLogger.TraceException(e, 0);
    end;
  end;
end;

procedure TfrmTestETW.LogFile(msg: string);
var f: textfile;
begin
  assignfile(f, 'c:\log.txt');
  if fileexists('c:\log.txt')
  then append(f)
  else rewrite(f);

  writeln(f, datetimetostr(now) + ' ' + msg);
  closefile(f);
end;

procedure TfrmTestETW.TimerRefreshTimer(Sender: TObject);
begin
  sbStatus.Panels[0].Text := 'EventEnabled : ' +
    BoolToStr(GenericLogger.EventEnabled, true);
  sbStatus.Panels[1].Text := 'EnableLevel : ' +
    IntToStr(GenericLogger.EnableLevel);
  sbStatus.Panels[2].Text := 'EnableFlags : ' +
    IntToStr(GenericLogger.EnableFlags);
end;

end.
