{******************************************************************************}
{                                                                              }
{ ETWTraceViewer                                                               }
{                                                                              }
{ Copyright (C) 2008 Franck SORIANO                                            }
{                                                                              }
{ This program is free software; you can redistribute it and/or                }
{  modify it under the terms of the GNU General Public License                 }
{ as published by the Free Software Foundation; either version 2               }
{ of the License, or (at your option) any later version.                       }
{                                                                              }
{ This program is distributed in the hope that it will be useful,              }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of               }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                }
{ GNU General Public License for more details.                                 }
{                                                                              }
{ You should have received a copy of the GNU General Public License            }
{ along with this program; if not, write to the Free Software                  }
{ Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,MA  02110-1301,USA.}
{                                                                              }
{******************************************************************************}
unit uProviderList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, uETWTraceControler;

type
  TfrmProviderList = class(TForm)
    lv: TListView;
    procedure lvCompare(Sender: TObject; Item1, Item2: TListItem; Data: Integer;
      var Compare: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
  protected
    procedure DoCreate; override;
  public
  end;

var
  frmProviderList: TfrmProviderList;

implementation
uses uETWWmiInfo;

{$R *.dfm}

procedure TfrmProviderList.DoCreate;
var
  provList : TStrings;
  guidStr : string;
  enabled : boolean;
  item : TListItem;
  i : integer;
  Info : TETWWMIInfo;

begin
  inherited DoCreate;
  Info := WmiInfo;
  provList := TStringList.Create;
  lv.Items.BeginUpdate;
  try
    TETWTraceControler.EnumerateRegisteredProviders(provList);
    lv.Items.Clear;
    for i := 0 to provList.Count -1 do
    begin
      TETWTraceControler.DecodeProviderInfo(provList[i], guidStr, enabled);
      item := lv.Items.Add;
      item.Caption := Info.GetProviderName(GuidStr);
      item.SubItems.Add(guidStr);
      item.SubItems.Add(BoolToStr(enabled, true));
    end;
  finally
    lv.Items.EndUpdate;
    provList.Free;
  end;
end;

procedure TfrmProviderList.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
  frmProviderList := nil;
end;

procedure TfrmProviderList.lvCompare(Sender: TObject; Item1, Item2: TListItem;
  Data: Integer; var Compare: Integer);
var s1, s2 : string;
begin
  s1 := Item1.Caption;
  s2 := Item2.Caption;
  if s1 = ''
  then Compare := -1
  else begin
    if s2 = ''
    then Compare := 1
    else begin
      if s1[1] = '{'
      then Compare := 1
      else begin
        if s2[1] = '{'
        then Compare := -1
        else Compare := CompareText(s1, s2);
      end;
    end;
  end;
end;

end.
